import java.awt.Color;
import java.util.LinkedList;
import java.util.List;

public class Circle {
    public  double xpos;
    public  double ypos;
    public double vx;
    public  double vy;
    public  double radius;
    public  Color hsbColor;
    public double angle;
    List<Bullet> bullets;
    public boolean hasflag;
    public double HP;
    int score;
    
    public Circle(double x,double y,Color color)
    {
            xpos =x;
            ypos = y;
            hsbColor = color;
            vx = 0;
            vy = 0;
            radius = 1;
            bullets = new LinkedList();
            hasflag = false;
            score = 0;
            angle = Math.atan2(vy,vx);
            HP = 3;
    }
    public double getAngle(){
        return Math.atan2(vy,vx);
    }
    public  void move(double x,double y,CatchGAME game,int i){
        if(xpos+vx >20) vx = -vx*0.37;
        if(xpos+vx <0) vx = -vx*0.37;
        if(ypos+vy >20) vy = -vy*0.37;
        if(ypos+vy <0) vy = -vy*0.37;
        if(Math.sqrt(Math.pow(this.xpos-game.Circles[(i+1)%2].xpos,2))<2 
                &&Math.sqrt(Math.pow(this.ypos-game.Circles[(i+1)%2].ypos,2))<2){
            double xtmp = vx;
            double ytmp = vy;
            vx = game.Circles[(i+1)%2].vx;
            vy = game.Circles[(i+1)%2].vy;
            game.Circles[(i+1)%2].vx = xtmp;
            game.Circles[(i+1)%2].vy = ytmp;
        }
        this.vx = vx + x;
        this.vy = vy + y;
        xpos = xpos+vx;
        ypos = ypos+vy;
        for(Bullet b : bullets){
            
            if(b.vx<0.00000000001&&b.vx>-0.00000000001&&b.vy<0.00000000001&&b.vy>-0.00000000001) bullets.remove(b);
                    b.move();
            }
            
    }
    public void fire(){
        bullets.add(new Bullet(this));
    }
    public void rotate(){
        vx = Math.sqrt(Math.pow(vx, 2)+Math.pow(vy, 2))*Math.cos(getAngle()+0.3);
        vy = Math.sqrt(Math.pow(vx, 2)+Math.pow(vy, 2))*Math.sin(getAngle()+0.3);
    }
    
    public  void draw(){
        StdDraw.setPenColor(this.hsbColor);
         for(Bullet b : bullets){
                if(b.vx<0.00000000001&&b.vx>-0.00000000001&&b.vy<0.00000000001&&b.vy>-0.00000000001) bullets.remove(b);
                b.draw();
            }
            StdDraw.filledCircle(this.xpos, this.ypos, this.radius);
            StdDraw.setPenColor(Color.BLACK);
            StdDraw.setPenRadius(0.03);
            StdDraw.line(xpos, ypos,xpos+Math.cos(getAngle()),ypos+Math.sin(getAngle()));
            StdDraw.setPenRadius();
            StdDraw.setPenColor(this.hsbColor);
            StdDraw.setPenRadius(0.01);
            StdDraw.line(xpos-1, ypos+1.2,xpos+2.0/3.0*HP-1,ypos+1.2);
            
            StdDraw.setPenRadius();
           
    }
    /*
    return 0 if ok
    return 1 if dies
    return 2 if capture
    return 3 if send
    return 4 if false
    return 5 if recapture
    */
    public int check(CatchGAME game,int x){
        int y = (x+1)%2;
        if(x!=1 &&x!=0) return 4;
        
        for(Bullet b : game.Circles[y].bullets){
            if(Math.sqrt(Math.pow(this.xpos-b.xpos,2))<1 
                &&Math.sqrt(Math.pow(this.ypos-b.ypos,2))<1){
            if(y==0){
            HP-= 10*Math.sqrt(Math.pow(b.vx, 2)+Math.pow(b.vy, 2));
            if(HP<=0){
            this.respawn(20,0);
            game.flag[y].vx=0;
            game.flag[y].vy =0;
            
            if(game.flag[y].xpos<0 ||game.flag[y].ypos<0 ||game.flag[y].xpos>20
                    ||game.flag[y].ypos>20){
            if(y==0)
            game.flag[y].respawn(0,0);
            if(y==1)
            game.flag[y].respawn(20,20);
            }
            }
            }
            if(y==1){
            HP-= 10*Math.sqrt(Math.pow(b.vx, 2)+Math.pow(b.vy, 2));
            if(HP<=0){
            this.respawn(0,20);
            game.flag[y].vx=0;
            game.flag[y].vy =0;
            
            if(game.flag[y].xpos<0 ||game.flag[y].ypos<0 ||game.flag[y].xpos>20
                    ||game.flag[y].ypos>20){
            if(y==0)
            game.flag[y].respawn(0,0);
            if(y==1)
            game.flag[y].respawn(20,20);
            }
            }
            }
            
            game.Circles[y].bullets.remove(b);
            return 1;
        }
        }
        if(hasflag &&Math.sqrt(Math.pow(this.xpos-game.base[x].xpos,2))<1 
                &&Math.sqrt(Math.pow(this.ypos-game.base[x].ypos,2))<1){
            if(y==0)
            game.flag[y].respawn(0,0);
            if(y==1)
            game.flag[y].respawn(20,20);
            hasflag = false;
            score++;
            return 3;
        }
        
        if(Math.sqrt(Math.pow(this.xpos-game.flag[x].xpos,2))<1 
                &&Math.sqrt(Math.pow(this.ypos-game.flag[x].ypos,2))<1){
            if(x==0)
            game.flag[x].respawn(0,0);
            if(x==1)
            game.flag[x].respawn(20,20);
            return 5;
        }
        if(Math.sqrt(Math.pow(this.xpos-game.flag[y].xpos,2))<1 
                &&Math.sqrt(Math.pow(this.ypos-game.flag[y].ypos,2))<1){
            hasflag = true;
            return 2;
        }
        
        
        
        return 0;
    }

    
    public void respawn(double x,double y) {
        xpos =x;
            ypos = y;
            HP =3;
            vx = 0;
            vy = 0;
            radius = 1;
            hasflag = false;
    }
}